/* parser auto-generated by pidl */

#include "includes.h"
#include "bin/default/librpc/gen_ndr/ndr_frsblobs.h"

#include "librpc/gen_ndr/ndr_misc.h"
#include "librpc/gen_ndr/ndr_security.h"
#include "librpc/gen_ndr/ndr_frsrpc.h"
#include "librpc/gen_ndr/ndr_bkupblobs.h"
#include "librpc/gen_ndr/ndr_fscc.h"
static enum ndr_err_code ndr_push_decode_nt_backup_file(struct ndr_push *ndr, int flags, const struct decode_nt_backup_file *r)
{
	NDR_PUSH_CHECK_FN_FLAGS(ndr, flags);
	if (flags & NDR_IN) {
		NDR_CHECK(ndr_push_bkup_NTBackupFile(ndr, NDR_SCALARS|NDR_BUFFERS, &r->in.file));
	}
	if (flags & NDR_OUT) {
	}
	return NDR_ERR_SUCCESS;
}

static enum ndr_err_code ndr_pull_decode_nt_backup_file(struct ndr_pull *ndr, int flags, struct decode_nt_backup_file *r)
{
	NDR_PULL_CHECK_FN_FLAGS(ndr, flags);
	if (flags & NDR_IN) {
		NDR_CHECK(ndr_pull_bkup_NTBackupFile(ndr, NDR_SCALARS|NDR_BUFFERS, &r->in.file));
	}
	if (flags & NDR_OUT) {
	}
	return NDR_ERR_SUCCESS;
}

_PUBLIC_ void ndr_print_decode_nt_backup_file(struct ndr_print *ndr, const char *name, int flags, const struct decode_nt_backup_file *r)
{
	ndr_print_struct(ndr, name, "decode_nt_backup_file");
	if (r == NULL) { ndr_print_null(ndr); return; }
	ndr->depth++;
	if (flags & NDR_SET_VALUES) {
		ndr->flags |= LIBNDR_PRINT_SET_VALUES;
	}
	if (flags & NDR_IN) {
		ndr_print_struct(ndr, "in", "decode_nt_backup_file");
		ndr->depth++;
		ndr_print_bkup_NTBackupFile(ndr, "file", &r->in.file);
		ndr->depth--;
	}
	if (flags & NDR_OUT) {
		ndr_print_struct(ndr, "out", "decode_nt_backup_file");
		ndr->depth++;
		ndr->depth--;
	}
	ndr->depth--;
}

static enum ndr_err_code ndr_push_decode_frsrpc_StageHeader(struct ndr_push *ndr, int flags, const struct decode_frsrpc_StageHeader *r)
{
	NDR_PUSH_CHECK_FN_FLAGS(ndr, flags);
	if (flags & NDR_IN) {
		NDR_CHECK(ndr_push_frsrpc_StageHeader(ndr, NDR_SCALARS, &r->in.header));
		NDR_CHECK(ndr_push_bkup_NTBackupFile(ndr, NDR_SCALARS|NDR_BUFFERS, &r->in.data));
	}
	if (flags & NDR_OUT) {
	}
	return NDR_ERR_SUCCESS;
}

static enum ndr_err_code ndr_pull_decode_frsrpc_StageHeader(struct ndr_pull *ndr, int flags, struct decode_frsrpc_StageHeader *r)
{
	NDR_PULL_CHECK_FN_FLAGS(ndr, flags);
	if (flags & NDR_IN) {
		NDR_CHECK(ndr_pull_frsrpc_StageHeader(ndr, NDR_SCALARS, &r->in.header));
		NDR_CHECK(ndr_pull_bkup_NTBackupFile(ndr, NDR_SCALARS|NDR_BUFFERS, &r->in.data));
	}
	if (flags & NDR_OUT) {
	}
	return NDR_ERR_SUCCESS;
}

_PUBLIC_ void ndr_print_decode_frsrpc_StageHeader(struct ndr_print *ndr, const char *name, int flags, const struct decode_frsrpc_StageHeader *r)
{
	ndr_print_struct(ndr, name, "decode_frsrpc_StageHeader");
	if (r == NULL) { ndr_print_null(ndr); return; }
	ndr->depth++;
	if (flags & NDR_SET_VALUES) {
		ndr->flags |= LIBNDR_PRINT_SET_VALUES;
	}
	if (flags & NDR_IN) {
		ndr_print_struct(ndr, "in", "decode_frsrpc_StageHeader");
		ndr->depth++;
		ndr_print_frsrpc_StageHeader(ndr, "header", &r->in.header);
		ndr_print_bkup_NTBackupFile(ndr, "data", &r->in.data);
		ndr->depth--;
	}
	if (flags & NDR_OUT) {
		ndr_print_struct(ndr, "out", "decode_frsrpc_StageHeader");
		ndr->depth++;
		ndr->depth--;
	}
	ndr->depth--;
}

static enum ndr_err_code ndr_push_decode_FileNetworkOpenInformation(struct ndr_push *ndr, int flags, const struct decode_FileNetworkOpenInformation *r)
{
	NDR_PUSH_CHECK_FN_FLAGS(ndr, flags);
	if (flags & NDR_IN) {
		NDR_CHECK(ndr_push_fscc_FileNetworkOpenInformation(ndr, NDR_SCALARS, &r->in.data));
	}
	if (flags & NDR_OUT) {
	}
	return NDR_ERR_SUCCESS;
}

static enum ndr_err_code ndr_pull_decode_FileNetworkOpenInformation(struct ndr_pull *ndr, int flags, struct decode_FileNetworkOpenInformation *r)
{
	NDR_PULL_CHECK_FN_FLAGS(ndr, flags);
	if (flags & NDR_IN) {
		NDR_CHECK(ndr_pull_fscc_FileNetworkOpenInformation(ndr, NDR_SCALARS, &r->in.data));
	}
	if (flags & NDR_OUT) {
	}
	return NDR_ERR_SUCCESS;
}

_PUBLIC_ void ndr_print_decode_FileNetworkOpenInformation(struct ndr_print *ndr, const char *name, int flags, const struct decode_FileNetworkOpenInformation *r)
{
	ndr_print_struct(ndr, name, "decode_FileNetworkOpenInformation");
	if (r == NULL) { ndr_print_null(ndr); return; }
	ndr->depth++;
	if (flags & NDR_SET_VALUES) {
		ndr->flags |= LIBNDR_PRINT_SET_VALUES;
	}
	if (flags & NDR_IN) {
		ndr_print_struct(ndr, "in", "decode_FileNetworkOpenInformation");
		ndr->depth++;
		ndr_print_fscc_FileNetworkOpenInformation(ndr, "data", &r->in.data);
		ndr->depth--;
	}
	if (flags & NDR_OUT) {
		ndr_print_struct(ndr, "out", "decode_FileNetworkOpenInformation");
		ndr->depth++;
		ndr->depth--;
	}
	ndr->depth--;
}

static const struct ndr_interface_call frsblobs_calls[] = {
	{
		"decode_nt_backup_file",
		sizeof(struct decode_nt_backup_file),
		(ndr_push_flags_fn_t) ndr_push_decode_nt_backup_file,
		(ndr_pull_flags_fn_t) ndr_pull_decode_nt_backup_file,
		(ndr_print_function_t) ndr_print_decode_nt_backup_file,
		{ 0, NULL },
		{ 0, NULL },
	},
	{
		"decode_frsrpc_StageHeader",
		sizeof(struct decode_frsrpc_StageHeader),
		(ndr_push_flags_fn_t) ndr_push_decode_frsrpc_StageHeader,
		(ndr_pull_flags_fn_t) ndr_pull_decode_frsrpc_StageHeader,
		(ndr_print_function_t) ndr_print_decode_frsrpc_StageHeader,
		{ 0, NULL },
		{ 0, NULL },
	},
	{
		"decode_FileNetworkOpenInformation",
		sizeof(struct decode_FileNetworkOpenInformation),
		(ndr_push_flags_fn_t) ndr_push_decode_FileNetworkOpenInformation,
		(ndr_pull_flags_fn_t) ndr_pull_decode_FileNetworkOpenInformation,
		(ndr_print_function_t) ndr_print_decode_FileNetworkOpenInformation,
		{ 0, NULL },
		{ 0, NULL },
	},
	{ .name = NULL }
};

static const char * const frsblobs_endpoint_strings[] = {
	"ncacn_np:[\\pipe\\frsblobs]", 
};

static const struct ndr_interface_string_array frsblobs_endpoints = {
	.count	= 1,
	.names	= frsblobs_endpoint_strings
};

static const char * const frsblobs_authservice_strings[] = {
	"host", 
};

static const struct ndr_interface_string_array frsblobs_authservices = {
	.count	= 1,
	.names	= frsblobs_authservice_strings
};


const struct ndr_interface_table ndr_table_frsblobs = {
	.name		= "frsblobs",
	.syntax_id	= {
		{0x12345777,0x1234,0xabcd,{0x00,0x01},{0x00,0x00,0x00,0x04}},
		NDR_FRSBLOBS_VERSION
	},
	.helpstring	= NDR_FRSBLOBS_HELPSTRING,
	.num_calls	= 3,
	.calls		= frsblobs_calls,
	.endpoints	= &frsblobs_endpoints,
	.authservices	= &frsblobs_authservices
};

